#!/usr/bin/env python

"""
Copyright (c) 2006-2024 sqlmap developers (https://sqlmap.org/)
See the file 'LICENSE' for copying permission
"""

from lib.core.common import Backend
from lib.core.common import Format
from lib.core.data import conf
from lib.core.data import kb
from lib.core.data import logger
from lib.core.enums import DBMS
from lib.core.session import setDbms
from lib.core.settings import METADB_SUFFIX
from lib.core.settings import SQLITE_ALIASES
from lib.request import inject
from plugins.generic.fingerprint import Fingerprint as GenericFingerprint

# 该插件用于检测sqlite数据库，通过执行一些常用函数来判断数据库类型，并获取数据库版本信息，最后返回检测结果。 
# 通过执行SQLITE_VERSION()函数来判断数据库类型，获取数据库版本信息，检测数据库是否存在。

class Fingerprint(GenericFingerprint):
    def __init__(self):
        # 初始化父类Fingerprint，对象的数据库管理系统类型设置为SQLite
        GenericFingerprint.__init__(self, DBMS.SQLITE)

    def getFingerprint(self):
        value = ""
        # 获取Web服务器的操作系统指纹
        wsOsFp = Format.getOs("web server", kb.headersFp)

        if wsOsFp:
            value += "%s\n" % wsOsFp

        # 获取数据库服务器的操作系统指纹
        if kb.data.banner:
            dbmsOsFp = Format.getOs("back-end DBMS", kb.bannerFp)

            if dbmsOsFp:
                value += "%s\n" % dbmsOsFp

        value += "back-end DBMS: "

        # 如果不是详尽指纹模式，直接返回DBMS类型
        if not conf.extensiveFp:
            value += DBMS.SQLITE
            return value

        # 获取当前活动的数据库管理系统信息
        actVer = Format.getDbms()
        blank = " " * 15
        value += "active fingerprint: %s" % actVer

        # 如果有数据库版本信息的指纹，则进行处理
        if kb.bannerFp:
            banVer = kb.bannerFp.get("dbmsVersion")

            if banVer:
                banVer = Format.getDbms([banVer])
                value += "\n%sbanner parsing fingerprint: %s" % (blank, banVer)

        # 获取HTML错误消息中的指纹
        htmlErrorFp = Format.getErrorParsedDBMSes()

        if htmlErrorFp:
            value += "\n%shtml error message fingerprint: %s" % (blank, htmlErrorFp)

        return value

    def checkDbms(self):
        """
        References for fingerprint:

        * http://www.sqlite.org/lang_corefunc.html
        * http://www.sqlite.org/cvstrac/wiki?p=LoadableExtensions
        """

        # 如果不是详尽指纹模式并且数据库管理系统在已知的SQLite别名之中
        if not conf.extensiveFp and Backend.isDbmsWithin(SQLITE_ALIASES):
            setDbms(DBMS.SQLITE)

            self.getBanner()

            return True

        infoMsg = "testing %s" % DBMS.SQLITE
        logger.info(infoMsg)

        # 检查布尔表达式，验证是否为SQLite
        result = inject.checkBooleanExpression("LAST_INSERT_ROWID()=LAST_INSERT_ROWID()")

        if result:
            infoMsg = "confirming %s" % DBMS.SQLITE
            logger.info(infoMsg)

            # 进一步确认数据库版本
            result = inject.checkBooleanExpression("SQLITE_VERSION()=SQLITE_VERSION()")

            if not result:
                warnMsg = "the back-end DBMS is not %s" % DBMS.SQLITE
                logger.warning(warnMsg)

                return False
            else:
                infoMsg = "actively fingerprinting %s" % DBMS.SQLITE
                logger.info(infoMsg)

                # 依据RANDOMBLOB函数确定SQLite版本
                result = inject.checkBooleanExpression("RANDOMBLOB(-1)>0")
                version = '3' if result else '2'
                Backend.setVersion(version)

            setDbms(DBMS.SQLITE)

            self.getBanner()

            return True
        else:
            warnMsg = "the back-end DBMS is not %s" % DBMS.SQLITE
            logger.warning(warnMsg)

            return False

    def forceDbmsEnum(self):
        # 强制数据库管理系统枚举，设置数据库名称
        conf.db = "%s%s" % (DBMS.SQLITE, METADB_SUFFIX)
